"""
Genetic Programming approach for Behavior Trees
"""

import argparse

import genetic_programming
import behavior_tree as bt


def main():
    parser = argparse.ArgumentParser()
    parser.add_argument('-c', '--config', dest="config", help="spambase, mario_ai, jones, default")
    parser.add_argument('-s', '--scenario', dest="scenario", help="Path to .argos file")
    parser.add_argument('-b', '--budget', dest="budget", help="The budget", default=50000)
    input_args = parser.parse_args()
    # TODO: argparse parameter set
    # TODO: argparse scenario and set it in behavior_tree.py
    print("Starting genetic programming for behavior trees")
    print("Using configuration from {}".format(input_args.config))
    print("Running scenario {}".format(input_args.scenario))
    bt.scenario_file = input_args.scenario
    genetic_programming.budget = int(input_args.budget)
    if input_args.config == "jones":
        genetic_programming.jones.gp_jones()
    elif input_args.config == "default":
        pass
    else:
        print("Unknown configuration {}".format(input_args.config))


if __name__ == "__main__":
    main()
